From db9ce122b6c01ac95785749171a780b3ba2d2cb1 Mon Sep 17 00:00:00 2001
From: Akash Mehrotra <mehrotra.akash@gmail.com>
Date: Thu, 30 Jun 2011 23:47:27 +0530
Subject: [PATCH] implement pl_delete

---
 modules/lua/libs/playlist.c        |   11 +++++++++++
 share/lua/http/requests/README.txt |    5 +++--
 share/lua/http/requests/status.xml |    3 +--
 3 files changed, 15 insertions(+), 4 deletions(-)

diff --git a/modules/lua/libs/playlist.c b/modules/lua/libs/playlist.c
index df0f15c..46fb3fa 100644
--- a/modules/lua/libs/playlist.c
+++ b/modules/lua/libs/playlist.c
@@ -138,6 +138,16 @@ static int vlclua_playlist_goto( lua_State * L )
     return vlclua_push_ret( L, i_ret );
 }
 
+static int vlclua_playlist_delete( lua_State * L )
+{
+    int i_id = luaL_checkint( L, 1 );
+    playlist_t *p_playlist = vlclua_get_playlist_internal( L );
+    PL_LOCK;
+    int i_ret = playlist_DeleteFromInput(p_playlist, playlist_ItemGetById( p_playlist, i_id ) -> p_input, true );
+    PL_UNLOCK;
+    return vlclua_push_ret( L, i_ret );
+}
+
 static int vlclua_playlist_add( lua_State *L )
 {
     int i_count;
@@ -378,6 +388,7 @@ static const luaL_Reg vlclua_playlist_reg[] = {
     { "current", vlclua_playlist_current },
     { "sort", vlclua_playlist_sort },
     { "status", vlclua_playlist_status },
+    { "delete", vlclua_playlist_delete },
     { NULL, NULL }
 };
 
diff --git a/share/lua/http/requests/README.txt b/share/lua/http/requests/README.txt
index a367adc..e59e5dc 100644
--- a/share/lua/http/requests/README.txt
+++ b/share/lua/http/requests/README.txt
@@ -44,8 +44,9 @@ status.xml:
 > jump to previous item:
   ?command=pl_previous
 
-> delete item <id> from playlist:
-  ?command=pl_delete&id=<id>
+> delete item <id> from playlist:  
+  ?command=pl_delete&id=<id>    
+  Note: pl_delete is deprecated 
 
 > empty playlist:
   ?command=pl_empty
diff --git a/share/lua/http/requests/status.xml b/share/lua/http/requests/status.xml
index 3900454..d5b49ac 100644
--- a/share/lua/http/requests/status.xml
+++ b/share/lua/http/requests/status.xml
@@ -83,8 +83,7 @@ elseif command == "pl_next" then
 elseif command == "pl_previous" then
   vlc.playlist.prev()
 elseif command == "pl_delete" then
-  vlc.msg.err("FIXME: pl_delete unimplemented")
-  --vlc.playlist.delete(id)
+  vlc.playlist.delete(id)
 elseif command == "pl_empty" then
   vlc.playlist.clear()
 elseif command == "pl_sort" then
-- 
1.7.1

